"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _fs = _interopRequireDefault(require("fs"));

function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

/**
 * A list of all PIPs shipped with WSC and their default file names.
 *
 * @see {@link https://github.com/WoltLab/WCF/tree/master/wcfsetup/install/files/lib/system/package/plugin}
 */
var DEFAULT_PIP_FILENAMES = {
  acpTemplate: 'acptemplates.tar',
  file: 'files.tar',
  language: 'language/*.xml',
  script: null,
  sql: 'install.sql',
  style: null,
  template: 'templates.tar'
};

var PipParser = /*#__PURE__*/function () {
  function PipParser(additionalPips) {
    (0, _classCallCheck2["default"])(this, PipParser);
    this.additionalPips = additionalPips;
  }

  (0, _createClass2["default"])(PipParser, [{
    key: "run",
    value: function run(instructions) {
      var _this = this;

      var pips = this.getPipList();
      return {
        files: instructions.map(function (it) {
          return _this.getFileName(it, pips);
        }),
        styles: this.getStylePaths(instructions)
      };
    }
  }, {
    key: "getStylePaths",
    value: function getStylePaths(pips) {
      var result = [];

      var _iterator = _createForOfIteratorHelper(pips),
          _step;

      try {
        for (_iterator.s(); !(_step = _iterator.n()).done;) {
          var pip = _step.value;

          if (pip.type == 'style') {
            result.push(pip.path.replace('.tar', ''));
          }
        }
      } catch (err) {
        _iterator.e(err);
      } finally {
        _iterator.f();
      }

      return result;
    }
  }, {
    key: "getPipList",
    value: function getPipList() {
      var that = this;
      var pipList = DEFAULT_PIP_FILENAMES;

      for (var pip in this.additionalPips) {
        pipList[pip] = that.additionalPips[pip];
      }

      return pipList;
    }
  }, {
    key: "getFileName",
    value: function getFileName(instruction, pips) {
      if (instruction.path) {
        return instruction.path;
      }

      if (pips[instruction.type]) {
        return pips[instruction.type];
      } // default value for all xml based pips


      if (_fs["default"].existsSync(instruction.type + '.xml')) {
        return instruction.type + '.xml';
      }

      throw new Error('No file was found with the default filename and no filename was provided for the PIP "' + instruction.type + '"');
    }
  }]);
  return PipParser;
}();

exports["default"] = PipParser;