#!/usr/bin/env node
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _TaskRunner = _interopRequireDefault(require("./TaskRunner"));

var _commander = _interopRequireDefault(require("commander"));

var _package = _interopRequireDefault(require("../package.json"));

var collectPips = function collectPips(value, list) {
  var splitted = value.split('=');
  list[splitted[0]] = splitted[1];
  return list;
};

_commander["default"].version(_package["default"].version).option('--pip [value]', 'if default files for custom PIPs are used, use this parameter to specify the default', collectPips, {}).option('-s, --source [value]', 'The path where the package files should be read from (defaults to cwd)', '.').option('-d, --destination [value]', 'The path the resulting archive will be saved to (defaults to cwd)', '.').option('-q, --quiet', 'omit any output').parse(process.argv);

(function (program) {
  var options = program.opts(); // Run the program.

  new _TaskRunner["default"]({
    pips: options.pip,
    source: options.source,
    destination: options.destination,
    quiet: options.quiet
  }).run()["catch"](function (err) {
    console.error(err);
  });
})(_commander["default"]);